<template>
    <div class="">
            <page-header title="Locations">
              <div slot="nav">
                <div class=" drowpdown mr-3">
                    <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-plus-circle mr-3"></i>Exporter vers
                    </button>
                    <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                          <a :href="excelUrl"  class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-excel t-plus-1 text-success fa-fw fa-lg "></i> EXCEL</a>
                          <a href="javascript:;" class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-pdf t-plus-1 text-danger fa-fw fa-lg "></i> PDF</a>
                    </div>
                </div>
              </div>
            </page-header>
            <div class="col-md-12">
              <div :class="['card bg-transparent']" >
               <div :class="['card-header pl-0']">
                    <h3 class="card-title pl-0">
                        <router-link to="/locations/ajout"  class="ml-4 btn btn-xs btn-primary text-xs">
                         <i class="fas fa-plus-circle right"></i>  Nouvelle Location
                        </router-link>
                    </h3>

                    <div class="card-tools d-flex">
                                                
                                                
                          <select name="" id="" class="filter form-control mr-1" @change="filterPayementEvent">
                            <option value="">Tous les payements</option>
                            <option class="text-capitalize" :value="payement.nature" v-for="payement in options.payements" :key="payement.id" v-text="payement.nature">Choisissez un role</option>
                             
                          </select>
                          <select  name="" id="" class="  filter form-control mr-1" @change="filterStatutEvent">
                            <option class="text-capitalize"  value="">Tous les déroulements</option>
                            <option class="text-capitalize" value="running" >En cours</option>
                            <option class="text-capitalize" value="waiting" >En attente</option>
                            <option class="text-capitalize" value="over" >Terminé</option>

                             
                          </select>
                         <filter-bar class="filter-search"></filter-bar>
                    </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body table-responsive  p-0 " v-show="!NoDataForSearch && !NoDataAtAll">
                    <vuetable :css="table"  ref="vuetable" :api-url="url" :fields="columns" 
                           pagination-path=""
                           @vuetable:loading="onLoading" @vuetable:loaded="onLoadingDone"
                           :append-params="moreParams" 
                           :per-page="50"
                           :http-options="httpOptions"
                           detail-row-component="mdetail-row-locations"
                           @vuetable:pagination-data="onPaginationData">
                           <!-- <template slot="extends" slot-scope="props">   
                                <div class="custom-actions ">
                                    <button class="ml-2 btn btn-xs btn-default"
                                    @click="onCellClicked(props.rowData)">
                                    <i class="fas fa-caret-down" v-if="isDetailRowOpened(props.rowData.id)"></i>
                                    <i class="fas fa-caret-right" v-else></i>
                                      <span class="hidden-xs"></span>
                                    </button>
                                </div>
                            </template> -->
                           <template slot="vehicule" slot-scope="props">   
                            <div class="">
                                        <span> {{ props.rowData.vehicule.libelle}}</span> 
                            </div>
                            </template>
                            <template slot="client" slot-scope="props">   
                            <div class="">
                                        <span> {{ props.rowData.client.nomComplet}} </span> 
                            </div>
                            </template>
                            <template slot="montant" slot-scope="props">   
                            <div class="">
                                        <span> {{ monnaie(props.rowData.montant) }} F cfa</span> 
                            </div>
                            </template>
                            <template slot="description" slot-scope="props">   
                            <div class="">
                              <span v-if="props.rowData.parent_id!=null"  :class="['']"> Prolongement </span>
                              <span v-else  :class="['']"> Location </span>
                              <span  :class="['']"> {{props.rowData.nbr_jour >1 ? props.rowData.nbr_jour+' jours' : props.rowData.nbr_jour+" jour"}}  </span>
                               
                              <span  :class="['']"> | Du  <strong>{{ props.rowData.date_dbt| toDate }}</strong> au <strong>{{ props.rowData.date_fin| toDate }} </strong>   </span>

                            </div>
                            </template>
                             <template slot="statut" slot-scope="props">   
                            <div class="">
                                                <span v-if="props.rowData.en_cours=='En cours'"  :class="['badge badge-primary text-uppercase bg-blue']"  v-text="props.rowData.en_cours"> </span> 
                                               <span v-else-if="props.rowData.en_cours=='En attente'"  :class="['badge badge-warning text-uppercase']"  v-text="props.rowData.en_cours"> </span> 
                                               <span v-else :class="['badge badge-secondary text-uppercase']"  v-text="props.rowData.en_cours"> </span> 
                            </div>
                            </template>
                            <template slot="payement" slot-scope="props">   
                            <div class="">
                                      <template v-if="props.rowData.statut_payement">
                                              <span v-if="props.rowData.statut_payement.nature=='payé'"  :class="['text-uppercase text-success']"  v-text="props.rowData.statut_payement.nature"> </span> 
                                              <span v-else-if="props.rowData.statut_payement.nature=='reservé'"  :class="[' text-uppercase text-danger']"  v-text="props.rowData.statut_payement.nature"> </span> 
                                              <span v-else-if="props.rowData.statut_payement.nature=='avance'"  :class="['text-uppercase text_warning']"  v-text="props.rowData.statut_payement.nature"> </span> 
                                              <span v-else :class="['badge badge-secondary text-uppercase']">Inconnu </span> 
                                      </template>
                                      <template v-else>
                                               <span  :class="['badge badge-secondary text-uppercase']">Inconnu</span> 
                                      </template>
                            </div>
                            </template>
                            <template slot="actions" slot-scope="props">   
                            <div class="custom-actions">
                                <router-link class="btn btn-xs btn-primary"
                                :to="'locations/'+props.rowData.id">
                                <i class="fas fa-eye"></i>
                                </router-link >
                                 <button class="btn btn-xs btn-secondary"
                                @click="prolongerEvent(props.rowData)">
                                <i class="fas fa-retweet"></i>
                                </button>
                                <button class="btn btn-xs btn-danger"
                                @click="remove(props.rowData)">
                                <i class="fas fa-trash"></i> 
                                </button> 
                            </div>
                            </template>
                    </vuetable>
              </div>
              <pa @pagination:per-page="onChangeLimit" ref="pagination" :is-loading="isLoading"  :pager="[15,25,50,100]" @vuetable-pagination:change-page="onChangePage" v-show="!NoDataForSearch && !NoDataAtAll"   ></pa>

              <!-- /.card-body -->
               </div>
               <no-data-in-search v-show="pageInit" :search="searchTxt" :show="NoDataForSearch" :data-empty="NoDataAtAll"></no-data-in-search>
              <!-- Modal dbt -->
              <b-modal @hidden="reset" size="xl"  ref="inputModal" id="my-modal" :title="ModalTitle"  :centered="true" :scrollable="true">
                <form class="" method="POST" 
                               @keydown="form.errors.clear($event.target.name)" 
                               @change="form.errors.clear($event.target.name)">
                        <div class="form-group">
                            <div class="row">
                              
                                  <div class="col">
                                       <div class="form-check mt-1 ">
                                           <input class="form-check-input " type="checkbox" id="inlineCheckbox3" v-model="form.avec_chauffeur" name="avec_chauffeur" :checked="form.avec_chauffeur">
                                            <label class="form-check-label" for="inlineCheckbox3">Avec Chauffeur ?</label>
                                        </div>
                                       <div class="form-check  mt-1 ">
                                           <input class="form-check-input " type="checkbox" id="inlineCheckbox2" v-model="form.longue_duree" name=".longue_duree" :checked="form.longue_duree">
                                            <label class="form-check-label" for="inlineCheckbox2">Longue durée ?</label>
                                        </div>
                                       <div class="form-check  mt-1 ">
                                           <input class="form-check-input " type="checkbox" id="inlineCheckbox1" v-model="form.client.ancien_client"
                                            name="client.ancien_client" :checked="form.client.ancien_client" @change="fixChange">
                                            <label class="form-check-label" for="inlineCheckbox1">Nouveau client ?</label>
                                        </div>
                                 </div>
                                 <div class="col-md-4">
                                      <label class="">Date de début de la location</label>
                                      <VueCtkDateTimePicker format='YYYY-MM-DD hh:mm' @input="updateDate(e,'date_dbt')" 
                                      buttonColor="rgb(129, 135, 140)"
                                      buttonNowTranslation="Maintenant"
                                      input-size="sm"
                                       id="dbt" color="rgb(129, 135, 140)" locale="fr" label="Choisissez la date de début"  v-model="form.date_dbt" :no-error="form.errors.has('date_dbt')" :no-label="true" />
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_dbt')" v-text="form.errors.get('date_dbt')"></span>

                                  </div>
                                   <div class="col-md-4">
                                       <label class="">Date de fin de la location</label>
                                       <VueCtkDateTimePicker format='YYYY-MM-DD hh:mm' 
                                       input-size="sm"
                                       buttonColor="rgb(129, 135, 140)"
                                       buttonNowTranslation="Maintenant"
                                       @input="updateDate(e,'date_fin')" id="fin" color="rgb(129, 135, 140)" locale="fr" label="Choisissez la date de retour" v-model="form.date_fin" :no-error="form.errors.has('date_fin')" :no-label="true"/>
                                       <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_fin')" v-text="form.errors.get('date_fin')"></span>
                                  </div>
                                  <div class="col">
                                       <label class="">Nbr de jours</label>
                                       <input class="form-control" type="text" disabled v-model="duree">
                                  </div>
                            </div>
                        </div>
                        <div class="form-group ">
                           <div class="row">
                             
                            <div class="col-md-5" v-if="!ancien_client">
                                      <label class="">Client</label>
                                      <multi-select :disabled="ancien_client" :class="['',form.errors.has('client_id')?'is-invalid':'']" 
                                          no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                          v-model="selectedClient"  :options="options.clients" 
                                          @input="onClientSelect"
                                          :show-labels="false" :searchable="true" :clear-on-select="false" 
                                          :close-on-select="true"  placeholder="Rechercher le client par son nom" label="nomComplet" track-by="id">
                                      </multi-select>
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('client_id')" v-text="form.errors.get('client_id')"></span>
                              </div>
                              <div class="col">
                                          <label class="">Prénom du client</label>
                                          <input :disabled="!ancien_client" :class="['form-control',form.errors.has('client.prenom')?'is-invalid':'']" name="client.prenom" v-model="form.client.prenom" type="text"/>
                                          <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.prenom')" v-text="form.errors.get('client.prenom')"></span>
                              </div>
                              <div class="col">
                                          <label class="">Nom du client</label>
                                          <input :disabled="!ancien_client"  :class="['form-control',form.errors.has('client.nom')?'is-invalid':'']"  name="client.nom" v-model="form.client.nom" type="text"/>
                                          <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.nom')" v-text="form.errors.get('client.nom')"></span>
                              </div>
                              <div class="col">
                                          <label class="">Adresse du client</label>
                                          <input :disabled="!ancien_client"  :class="['form-control',form.errors.has('client.adresse')?'is-invalid':'']"  name="client.adresse" v-model="form.client.adresse" type="text"/>
                                          <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.adresse')" v-text="form.errors.get('client.adresse')"></span>
                              </div>
                              <div class="col">
                                <label class="">Téléphone du client</label>
                                          <input :disabled="!ancien_client"  :class="['form-control',form.errors.has('client.telephone1')?'is-invalid':'']"  name="client.telephone1" v-model="form.client.telephone1" type="text"/>
                                          <span class="m-form__help m--font-danger"  v-if="form.errors.has('client.telephone1')" v-text="form.errors.get('client.telephone1')"></span>
                              </div>
                            </div>
                        </div>
                        <div class="form-group">
                             <div class="row">
                                    <div class="col-md-5">
                                      <label class="">Véhicule</label>
                                      <multi-select :class="['',form.errors.has('vehicule_id')?'is-invalid':'']" 
                                          no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                          v-model="selectedVehicule"  :options="options.vehicules" 
                                          @input="onVehiculeSelect"
                                          :show-labels="false" :searchable="true" :clear-on-select="false" 
                                          :close-on-select="true"  placeholder="Choisissez le véhicule" label="libelle" track-by="id">
                                      </multi-select>
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('vehicule_id')" v-text="form.errors.get('vehicule_id')"></span>
                                    </div>
                                    <div class="col">
                                          <label class="">Marque du véhicule</label>
                                          <input  :disabled="true" class="form-control " name="vehicule.marque" v-model="form.vehicule.marque" type="text"/>
                                    </div>
                                    <div class="col">
                                          <label class="">Type du véhicule</label>
                                          <input  :disabled="true" class="form-control " name="vehicule.tvehicule" v-model="form.vehicule.tvehicule" type="text"/>
                                    </div>
                                    <div class="col">
                                          <label class="">immatriculation </label>
                                          <input  :disabled="true" class="form-control " name="vehicule.immatriculation" v-model="form.vehicule.immatriculation" type="text"/>
                                    </div>
                                    <div class="col">
                                          <label class="">Tarif / jour </label>
                                          <input  :disabled="true" class="form-control " name="vehicule.tarif" v-model="form.vehicule.tarif" type="text"/>
                                    </div>
                             </div>
                        </div>
                        <div class="form-group" v-if="!form.avec_chauffeur">
                             <div class="row">
                               <div class="col-md-2 pt-3">
                                      <div class="form-check mt-4 ">
                                          <input class="form-check-input " type="checkbox" id="inlineCheckbox4" v-model="form.client_est_chauffeur" name="client_est_chauffeur" :checked="form.client_est_chauffeur">
                                            <label class="form-check-label" for="inlineCheckbox4">Le client est le chauffeur ?</label>
                                      </div>
                               </div>
                                 <div class="col">
                                      <label class="">Nom du chauffeur</label>
                                      <input  :disabled="form.client_est_chauffeur" :class="['form-control',form.errors.has('nom_chauffeur')?'is-invalid':'']"  name="nom_chauffeur" v-model="form.nom_chauffeur" type="text"/>
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('nom_chauffeur')" v-text="form.errors.get('nom_chauffeur')"></span>
                                  </div>
                                   <div class="col">
                                       <label class="">Nom du 2éme chauffeur</label>
                                      <input :disabled="form.nom_chauffeur==''"  :class="['form-control',form.errors.has('nom_chauffeur_2')?'is-invalid':'']" name="nom_chauffeur_2" v-model="form.nom_chauffeur_2" type="text"/>
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('nom_chauffeur_2')" v-text="form.errors.get('nom_chauffeur_2')"></span>
                                  </div>
                             </div>
                        </div>
                        <div class="form-group">
                             <div class="row">
                                 <div class="col">
                                      <label class="">Zone de location</label>
                                      <input  class="form-control " :class="['form-control',form.errors.has('zone_location')?'is-invalid':'']"  name="zone_location" v-model="form.zone_location" type="text"/>
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('zone_location')" v-text="form.errors.get('zone_location')"></span>
                                  </div>
                                   <div class="col-auto">
                                        <label class="">Livraison</label>
                                          <div class="form-check">
                                          <input class="form-check-input" type="radio" name="livraison_effective" id="exampleRadios1" :value="true" v-model="form.livraison_effective">
                                          <label class="form-check-label" for="exampleRadios1">
                                            Avec
                                          </label>
                                        </div>
                                        <div class="form-check">
                                          <input class="form-check-input" type="radio" name="livraison_effective" id="exampleRadios2" :value="false" v-model="form.livraison_effective">
                                          <label class="form-check-label" for="exampleRadios2">
                                            Sans
                                          </label>
                                        </div>
                                          <span class="m-form__help m--font-danger"  v-if="form.errors.has('livraison_effective')" v-text="form.errors.get('livraison_effective')"></span>
                                  </div>
                                  <div class="col_auto">
                                      <label class="">Frais de livraison </label>
                                      <input  class="form-control " :class="['form-control',form.errors.has('frais_livraison')?'is-invalid':'']"  name="frais_livraison" v-model="form.frais_livraison" type="text"/>
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('frais_livraison')" v-text="form.errors.get('frais_livraison')"></span>
                                  </div>
                                  <div class="col-auto">
                                      <label class="">Lavage</label>
                                      <input  class="form-control " :class="['form-control',form.errors.has('lavage_carburant')?'is-invalid':'']"  name="lavage_carburant" v-model="form.lavage_carburant" type="text"/>
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('lavage_carburant')" v-text="form.errors.get('lavage_carburant')"></span>
                                  </div>
                                  <div class="col">
                                      <label for="">Niveau de Carburant</label>
                                      <multi-select :class="['',form.errors.has('client_id')?'is-invalid':'']"  name="niveau_carburant"
                                          no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                          v-model="form.niveau_carburant"  :options="['1/4','1/2','3/4','plein']" 
                                          :show-labels="false" :searchable="false" :clear-on-select="false" 
                                          :close-on-select="true"  placeholder="Choisissez le niveau de carburant">
                                      </multi-select>
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('niveau_carburant')" v-text="form.errors.get('niveau_carburant')"></span>
                                  </div>

                             </div>
                             <div class="form-group row">
                                <div class="col-md-6">
                                      <label class="">Observations</label>
                                      <input  class="form-control " :class="['form-control',form.errors.has('observation')?'is-invalid':'']"  name="observation" v-model="form.observation" type="text"/>
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('observation')" v-text="form.errors.get('observation')"></span>
                                  </div>
                                   <div class="col">
                                      <label class="">Montant HTC</label>
                                      <input  class="form-control " :class="['form-control',form.errors.has('montant')?'is-invalid':'']"  name="montant" v-model="htc" type="text"/>
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('montant')" v-text="form.errors.get('montant')"></span>
                                  </div>
                                  <div class="col">
                                      <label class="">Montant TTC</label>
                                      <input  class="form-control " :class="['form-control',form.errors.has('montant_ttc')?'is-invalid':'']"  name="montant_ttc" v-model="ttc" type="text"/>
                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('montant_ttc')" v-text="form.errors.get('montant_ttc')"></span>
                                  </div>
                             </div>
                        </div>

               </form>
               <div class="" slot="modal-footer">

               </div>
                   <template v-slot:modal-footer="">
                      <div class="m-form__actions m-form__actions--solid" style="    display: flex;align-items: center;justify-content: flex-end;">
														<button @click="onSubmit()" type="button" :class="['btn btn-success btn-small mr-2',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="false">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
                            <button @click="reset()" type="button" :class="['btn btn-secondary btn-small mr-2']" :disabled="isLoading">Fermer</button>
											</div>
                  </template>
            </b-modal>
            <!-- Modal fin -->
            <prolongement @prolongement-done="actualiseVueTable"></prolongement>
</div>
    </div>
</template>

<script>
   import  Vuetable from "vuetable-2/src/components/Vuetable";
  import pa from './../../components/pagination/Pagination'
   import Form from "./../../classes/Form"
   import Master from "./../Master.vue";
   import Prolongement from "./../../components/ProlongementLocation.vue";


    export default {
        mixins: [Master],
        data(){
            return{
                
                ftime:true,
                hasData:false,
                per_page:15,
                url:"api/locations",
                moreParams:{
                  filter_statut_deroulement:'',
                  filter_statut_payement:'',
                  filter:""
                },
                options:{
                  clients:[],
                  vehicules:[],
                  payements:[]
                },
                selectedClient:"",
                selectedVehicule:"",
                isLoading:false,
                form : new Form({
                  avec_chauffeur:false,
                  client_id:"",
                  vehicule_id:"",
                  date_dbt:"",
                  date_fin:"",
                  nom_chauffeur:"",
                  nom_chauffeur_2:"",
                  livraison_effective:false,
                  client_est_chauffeur: false,
                  frais_livraison:0,
                  lavage_carburant:10000,
                  niveau_carburant:"",
                  nbr_jour : 0,
                  observation:"",
                  montant_ttc:"",
                  montant:"",
                  longue_duree:false,
                  zone_location:'',
                    client: {
                       nom:"",
                       prenom:"",
                       adresse:'',
                       telephone1:'',
                       ancien_client:false
                    },
                    vehicule :{
                       marque:"",
                       tvehicule:"",
                       immatriculation:"",
                       tarif:""
                    }
                }),
                columns : 
              [
                //                     {
                //     name: '__slot:extends',
                // },
                {
                    name: 'numero',
                    title:'N°',
                    titleClass: 'center aligned',
                    dataClass: 'center aligned text-uppercase',
                    sortField: 'id'
                },
                {
                name: '__slot:description',   // <----
                title: 'Description',
                titleClass: '',
                dataClass: ''
                },
                {
                name: '__slot:vehicule',   // <----
                title: 'Véhicule',
                titleClass: ' aligned',
                dataClass: ''
                },
                                                                {
                name: '__slot:payement',   // <----
                title: 'Payement',
                titleClass: 'center aligned',
                dataClass: 'center aligned'

                },
                 {
                name: '__slot:client',   // <----
                title: 'Client',
                titleClass: '',
                dataClass: ''

                },
                {
                name: '__slot:montant',   // <----
                title: 'Montant',
                titleClass: 'center aligned',
                dataClass: 'center aligned'

                },
                                                 {
                name: '__slot:statut',   // <----
                title: 'Statut',
                titleClass: 'center aligned',
                dataClass: 'center aligned'

                }
                   ,
                
                        {
                name: '__slot:actions',   // <----
                title: 'Actions',
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                }
                ],
                table: {
                    tableWrapper: '',
                    tableHeaderClass: 'mb-0',
                    tableBodyClass: 'mb-0',
                    tableClass: 'table table-striped table-hover',
                    ascendingIcon: 'fa fa-chevron-up',
                    descendingIcon: 'fa fa-chevron-down',
                    ascendingClass: 'sorted-asc',
                    descendingClass: 'sorted-desc',
                    sortableIcon: 'fa fa-sort',
                    detailRowClass: 'vuetable-detail-row',
                    handleIcon: 'fa fa-bars text-secondary',
                    renderIcon(classes, options) {
                      return `<i class="${classes.join(' ')}"></span>`
                    }
                  }
            }
        },
        created()
        {
           this.fetchOptions()
        },
        mounted() {
                this.$events.$on('filter-set', eventData => this.onFilterSet(eventData))
                this.$events.$on('filter-reset', e => this.onFilterReset())
        },
        computed:
         {
           excelUrl()
           {
             return '/locations/export?format=excel&q='+this.searchTxt+'&filter_statut_deroulement='+this.moreParams.filter_statut_deroulement+"&filter_statut_payement"+this.moreParams.filter_statut_payement;
           },
           pdfUrl()
           {
             return '/locations/export?format=pdf&q='+this.searchTxt
           },
            ModalTitle ()
            {
              return  this.modeEdit ? " Modification d'une  location"  : " Ajout d'une location"
            },
            ModalAction ()
            {
              return  this.modeEdit ? " Valider"  : "Valider"
            },
            shouldGoToFirstPage()
            {
              if(this.$refs.vuetable)
              {
                return (this.$refs.vuetable.tableData.length) - 1 == 0
              } 
              else
              {
                return false
              }
            },
            filterBarIsFilled()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter != "" ? true : false
                else
                 return false
            },
            searchTxt()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter
                else
                 return ""
            },
            NoDataForSearch()
            {

              return (this.hasData == false && this.filterBarIsFilled == true ) ? true : false
            
            },

            NoDataAtAll()
            {

              return (this.hasData == false && this.filterBarIsFilled == false ) ? true : false
            
            },
              ancien_client()
            {

              return this.form.client.ancien_client==true ? true : false
            
            },
             duree()
            {
                 
              if(this.form.date_dbt!="" && this.form.date_dbt!= null && this.form.date_dbt!=undefined && this.form.date_fin!="" && this.form.date_fin!=null && this.form.date_fin!=undefined) 
                {
                  var start = moment(this.form.date_dbt,"YYYY-MM-DD"); //todays date
                  var end = moment(this.form.date_fin,"YYYY-MM-DD"); // another date
                  var duration = moment.duration(end.diff(start));
                  this.form.nbr_jour = duration.asDays();

                  return  this.form.nbr_jour
                }
              else
                return 0
            
            },
             htc()
            {
               var montant = 0
               if(this.selectedVehicule!="" && this.selectedVehicule!=null && this.selectedVehicule!=undefined )
               {
                  if(this.selectedVehicule.hasOwnProperty('tarif'))
                    if(this.selectedVehicule.tarif!=null)
                    {
                      this.form.montant = this.duree * this.selectedVehicule.tarif + this.form.frais_livraison  + this.form.lavage_carburant
                      montant = this.form.montant 

                    }
               }
               
               return montant
            },
              ttc()
            {
                  this.form.montant_ttc = this.htc * (118/100)
                 return this.monnaie(this.htc * (118/100))
            }
         },
        methods: 
        {

            filterPayementEvent(e)
            {
                 this.moreParams.filter_statut_payement= e.target.value
                 Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            filterStatutEvent(e)
            {
                 this.moreParams.filter_statut_deroulement= e.target.value
                 Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            prolongerEvent(location)
            {
              window.event.$emit('prolongement-event',location)
            },
            //Actualisation de la  vuetable apres une prolongation
             actualiseVueTable()
            {
              this.$refs.vuetable.refresh()
            },
            updateDate(e,val) 
            {
                  if(this.form.errors.has(val))
                    this.form.errors.clear(val)
                  
            },
            fixChange(e)
            {
              if(e.target.checked==false)
             {
                   this.form.client_id = ""           
             }
                            
            this.form.client.nom=""
            this.form.client.prenom=""
            this.form.client.adresse=""
            this.form.client.telephone1=""
            this.selectedClient = ""
            if(this.form.client_est_chauffeur)
            this.form.nom_chauffeur = ""

            if(this.form.errors.has('client_id') || this.form.errors.has('client.nom')|| this.form.errors.has('client.adresse') || this.form.errors.has('client.telephone1') || this.form.errors.has('client.prenom'))
            {
                this.form.errors.clear('client_id')
                this.form.errors.clear('client.nom')
                this.form.errors.clear('client.prenom')
                this.form.errors.clear('client.adresse')
                this.form.errors.clear('client.telephone1')
            }

            },
            onClientSelect(e)
            {
                this.form.client_id = e.id
                this.form.client.nom= e.nom
                this.form.client.prenom= e.prenom
                this.form.client.adresse= e.adresse
                this.form.client.telephone1= e.telephone1

              if(this.form.errors.has('client_id') || this.form.errors.has('client.nom')|| this.form.errors.has('client.adresse') || this.form.errors.has('client.telephone1') || this.form.errors.has('client.prenom'))
              {
                  this.form.errors.clear('client_id')
                  this.form.errors.clear('client.nom')
                  this.form.errors.clear('client.prenom')
                  this.form.errors.clear('client.adresse')
                  this.form.errors.clear('client.telephone1')
              }
            },
              onVehiculeSelect(e)
            {
               this.form.vehicule_id = e.id
               this.form.vehicule.marque = e.marque.libelle
               this.form.vehicule.tvehicule = e.type_vehicule.libelle
               this.form.vehicule.immatriculation = e.plaque_immatriculation
               this.form.vehicule.tarif = e.tarif

              if(this.form.errors.has('vehicule_id') )
              {
                  this.form.errors.clear('vehicule_id')
              }
            },
            formatDate: function(value, fmt) 
            {
               return  toDateFormat(value, fmt)
            },
            monnaie: function(value) 
            {
               return  numeral(value).format('0,0');
            },
            actionOnThis: function(value, fmt) 
            {
               console.log(value,fmt)
            },
            onPaginationData (paginationData) 
            {
              if(this.pageInit==false)
                 {
                   
                 }
              else
              {
                
              }
              this.hasData = paginationData.data.length > 0
              this.$refs.pagination.setPaginationData(paginationData)
            },
            onChangePage (page) 
            {
               
               this.$refs.vuetable.changePage(page)
            },
            onChangeLimit(limit)
            {
               this.per_page = parseInt(limit)
               this.$refs.vuetable.httpOptions.params.per_page = this.per_page
               this.$refs.vuetable.reload()
            },
            onLoading() 
            {

               this.isLoading = true
                if(this.ftime==false)
                {
                    $('table.vuetable').block({ 
                        message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>', 
                        css: { border: 'none' },
                                                
                            // styles for the overlay 
                            overlayCSS:  { 
                                backgroundColor: '#000', 
                                opacity:         0.06, 
                                cursor:          'wait' 
                            },
                    }); 
                    
                }
                this.ftime = false
            },
            onLoadingDone() 
            {
               this.isLoading = false

                 if(this.pageInit==false)
                 {
                    this.pageInit = true
                 }
                if(this.ftime==false)
                {
                    $('table.vuetable').unblock()
                }
            },
            onFilterSet (filterText) {
                this.moreParams.filter =  filterText
                
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            onFilterReset () {
                this.moreParams.filter = ""
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            onCellClicked (data,event) {
                 console.log('cellClicked: ')
                this.$refs.vuetable.toggleDetailRow(data.id)
              },
             //Verifie si un detail row est ouvert ou fermé
              isDetailRowOpened(id)
              {
                return  this.$refs.vuetable.visibleDetailRows.includes(id)
              }, 
                          //On affiche le modal pour la création
            showModalOnCreate()
            {
    
                this.modeEdit = false
                this.reset()
                this.$refs['inputModal'].show()
              
            },
            //On affiche le modal pour l'édition
            showModalOnEdit(entity)
            {
               
                this.reset()
                this.modeEdit = true
                this.form.libelle = entity.libelle
                this.form.id=entity.id
                this.form.pays_id=entity.pays_id
                this.$refs['inputModal'].show()
             },
              //Initialisation du formulaire
              reset()
             {
                  this.modeEdit = false
                  this.isLoading = false
                  this.form.client.nom =""
                  this.form.client.adresse =""
                  this.form.client.telephone1 =""
                  this.form.client.ancien_client =false
                  this.form.vehicule.marque =""
                  this.form.vehicule.tvehicule =""
                  this.form.vehicule.immatriculation =""
                  this.form.vehicule.tarif =""
                  this.form.avec_chauffeur = false
                  this.form.client_est_chauffeur = false
                  this.form.longue_duree = false

                  this.selectedClient = ""
                  this.selectedVehicule = ""
                  this.form.date_dbt = ""
                  this.form.date_fin = ""
                  this.form.nom_chauffeur = ""
                  this.form.nom_chauffeur_2 = ""
                  this.form.zone_location = ""
                  this.form.livraison_effective = false
                  this.form.errors.clearAll()
                  this.$refs['inputModal'].hide()

                  if(this.moreParams.hasOwnProperty('filter'))
                  this.moreParams.filter=""
             },
              fetchOptions()
             {
               axios.get("/api/dispatcher/options/locations").then((response) => 
                { 
                    
                      this.options.clients = response.data.clients
                      this.options.vehicules = response.data.vehicules
                      this.options.payements = response.data.payements

                      
                      //envoie un event pour signifier le chargement des options
                      this.$emit('initOption');
                     // this.pageInit =true
                },
                (error) =>
                {
                  this.isLoading = false
                });
             },
                          //Gere l'action du formulaire
             onSubmit()
             {
                 //On réinitialise le chargement
                this.isLoading = true
                //Si on edite pas
                if(!this.modeEdit)
                  //on ajoute un nouveau
                   this.add()
                else 
                //alors on actualise
                  this.update()
             },
            //Ajoute une marque dans la BDD
            add()
            {
                //Requête ajax
                this.form.post(this.url).then((response) => 
                { 
                  console.log(response) 
                  if(response.success)
                  {
                  this.reset()
                  // on ramène les données sur la page 1
                  this.$refs.vuetable.refresh()
                  flash("<span>Enregistré <strong>avec succès</strong></span>")
                  }
                  else
                  {
                        flash("<span>Enregistrement <strong> impossible</strong></span>","error")
                        this.reset()

                  }


                },
                (error) =>
                {
                  this.isLoading = false
                });                  
            },
            //Actualise  un marque dans la BDD
            update()
            {
              
                //Requête ajax
                this.form.patch(this.url+"/"+this.form.id).then((value) => 
                {
                  
                   // on rafraichit la page des données actuelle
                  this.$refs.vuetable.reload()
                  //On remet à zero notre formulaire
                  this.reset()
                  //on affiche le message 
                  flash("<span>Modifié <strong>avec succès</strong></span>")
                  

                },
                (error) =>
                {
                  this.isLoading = false
                  //on affiche le message 
                  flash("<span>Ajout <strong>impossible</strong></span>","danger")
                });                  
            },
             excel()
             {
               var vm = this
                axios.get("/api/locations/export",{params:this.moreParams}).then((response) => 
                { 
                    
                    const url = window.URL.createObjectURL(new Blob([response.data]));
                    const link = document.createElement('a');
                    link.href = url;
                    link.setAttribute('download','locations.xlsx');
                    document.body.appendChild(link);
                    link.click();
                      
                },
                (error) =>
                {
                  this.isLoading = false
                });
             },

            remove(e)
             {
                    this.isLoading = true
                    alertConfirm("Cette action est <b>irréversible</b>, souhaitez-vous vraiment <b>supprimer</b> cette location de manière définitive ?","Suppréssion d'une location")
                    .then(result => {
                        if(result)
                        {
                           axios.delete("api/locations/"+e.id).then((response) => 
                            { 


                               // on rafraichit la page de donnée actuelle
                              !this.shouldGoToFirstPage ? this.$refs.vuetable.reload() : this.$refs.vuetable.refresh()

                              flash("<span>Supprimé <strong>avec succès</strong></span>")
                              this.isLoading = false

                            },
                            (error) =>
                            {
                              this.isLoading = false
                            });
                        }
                    })
                    .catch(error => {
                        reject(error);
                    });

                

             },
       },
        components:
        {

            Vuetable,Prolongement,
            pa
        },
        watch:
        {
          "form.livraison_effective":function(value)
          {
            if(value==true)
             this.form.frais_livraison = 5000
             else
              this.form.frais_livraison = 0
          },
         "form.niveau_carburant":function(value)
          {
            if(this.form.errors.has('niveau_carburant'))
            {
              this.form.errors.clear('niveau_carburant')
            }
          },
          "form.client_est_chauffeur":function(value)
          {
            if(value==true)
             {
               if(this.form.client.nom!="" && this.form.client.prenom!="")
               {
                 this.form.nom_chauffeur = this.form.client.prenom+" "+this.form.client.nom
                if(this.form.errors.has('nom_chauffeur'))
                {
                  this.form.errors.clear('nom_chauffeur')
                }
               }
             }
             else
             {
               this.form.nom_chauffeur = ""
                if(this.form.errors.has('nom_chauffeur'))
                {
                  this.form.errors.clear('nom_chauffeur')
                }
             }
          }
        }
    }
</script>
<style lang="scss" scoped>
  #my-modal input[type="text"],#my-modal select
  {
        height: 30px;
        min-height: 30px;
  }
  .form-group {
    margin-bottom: 1.6rem;
}
#my-modal .modal-body
{
  overflow-x: hidden !important;
}
.modal-dialog-scrollable .modal-body {
      overflow-y: auto;
        overflow-x: hidden !important;

      
}
.card-tools .filter
{
  flex:1;
  margin-right: 10px;
}
.card-tools .filter-search
{
  flex:1;
}
</style>